unit preview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  QRPrntr, ExtCtrls, StdCtrls, Spin, QRExport, QuickRpt, ComCtrls, QRCtrls;

type
  TFormpreview = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    SaveDialog1: TSaveDialog;
    QRCSVFilter1: TQRCSVFilter;
    QRTextFilter1: TQRTextFilter;
    QRHTMLFilter1: TQRHTMLFilter;
    Button9: TButton;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    QRPreview1: TQRPreview;
    QuickRep1: TQuickRep;
    Button10: TButton;
    procedure QRPreview1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button8Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure sh;
    procedure QRPreview1PageAvailable(Sender: TObject; PageNum: Integer);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure QuickRep1Preview(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    inp:boolean;
  end;

var
  Formpreview: TFormpreview;
  procedure crpreview(par,sender:tobject);

implementation



{$R *.DFM}
procedure crpreview(par,sender:tobject);
begin
   with TFormpreview.Create(TComponent(par)) do
   begin
      parent:=TWinControl(par);
      align:=alclient;
      inp:=true;
      QRPreview1.QRPrinter:=TQRPrinter(Sender);
      sh;
      show;
   end;
end;

procedure TFormpreview.sh;
begin
   SpinEdit1.Value:=1;
end;

procedure TFormpreview.QRPreview1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if Button=mbLeft then
      QRPreview1.Zoom:=QRPreview1.Zoom+5
   else
      if Button=mbRight then
         if QRPreview1.Zoom>50 then
            QRPreview1.Zoom:=QRPreview1.Zoom-5;
end;

procedure TFormpreview.Button8Click(Sender: TObject);
begin
   QRPreview1.ZoomToWidth;
end;

procedure TFormpreview.Button1Click(Sender: TObject);
begin
   SpinEdit1.Value:=1;
end;

procedure TFormpreview.Button2Click(Sender: TObject);
begin
   if QRPreview1.PageNumber>1 then
      SpinEdit1.value:=SpinEdit1.value-1;
end;

procedure TFormpreview.Button3Click(Sender: TObject);
begin
   if QRPreview1.QRPrinter.PageCount>QRPreview1.PageNumber then
      SpinEdit1.value:=SpinEdit1.value+1;
end;

procedure TFormpreview.Button4Click(Sender: TObject);
begin
   SpinEdit1.value:=QRPreview1.QRPrinter.PageCount;
end;

procedure TFormpreview.Button5Click(Sender: TObject);
var s:string;
begin
   s:=getcurrentdir;
   If SaveDialog1.Execute then
   begin
      if ExtractFileExt(SaveDialog1.FileName)='.csv' then
         QRPreview1.QRPrinter.ExportToFilter(TQRCommaSeparatedFilter.Create(SaveDialog1.FileName))
      else
         if ExtractFileExt(SaveDialog1.FileName)='.htm' then
            QRPreview1.QRPrinter.ExportToFilter(TQRHTMLDocumentFilter.Create(SaveDialog1.FileName))
         else
            qrpreview1.QRPrinter.Save(SaveDialog1.FileName);
   end;
   setcurrentdir(s);
{   HTML: TQRHTMLDocumentFilter
    ASCII: TQRAsciiExportFilter
    CSV: TQRCommaSeparatedFilter}
end;

procedure TFormpreview.Button7Click(Sender: TObject);
begin
   QRPreview1.QRPrinter.PrintSetup;
end;

procedure TFormpreview.Button6Click(Sender: TObject);
begin
   QRPreview1.QRPrinter.print;
end;

procedure TFormpreview.QRPreview1PageAvailable(Sender: TObject;
  PageNum: Integer);
begin
   Label3.Caption:='@'+IntToStr(QRPreview1.QRPrinter.PageCount)+'';
   if QRPreview1.QRPrinter.PageCount=0 then
   begin
      SpinEdit1.MinValue:=QRPreview1.QRPrinter.PageCount;
      SpinEdit1.MaxValue:=QRPreview1.QRPrinter.PageCount;
      SpinEdit1.Value:=QRPreview1.QRPrinter.PageCount;
   end else
   begin
      SpinEdit1.MinValue:=0;
      SpinEdit1.MaxValue:=QRPreview1.QRPrinter.PageCount;
      SpinEdit1.value:=1;
   end;
end;

procedure TFormpreview.SpinEdit1Change(Sender: TObject);
begin
  If QRPreview1.QRPrinter.PageCount>=SpinEdit1.Value then
     QRpreview1.PageNumber:=SpinEdit1.Value
  else
     SpinEdit1.value:=QRPreview1.QRPrinter.PageCount;
  button1.enabled:=not (SpinEdit1.value<=1);
  button2.enabled:=not (SpinEdit1.value<=1);
  button3.enabled:=not (SpinEdit1.value=QRPreview1.QRPrinter.PageCount);
  button4.enabled:=not (SpinEdit1.value=QRPreview1.QRPrinter.PageCount);
end;

procedure TFormpreview.Button9Click(Sender: TObject);
begin
   if opendialog1.Execute then
   begin
//      qrpreview1.QRPrinter.ClosePreview(quickrep1);
      QRPreview1.qrprinter.master := nil;
      QRPreview1.QRPrinter.Load(opendialog1.Filename);
      QRPreview1.PageNumber := 1;
      QRPreview1.PreviewImage.PageNumber := 1;
      QRPreview1PageAvailable(nil,1);
   end;
end;

procedure TFormpreview.QuickRep1Preview(Sender: TObject);
begin
   QRPreview1.QRPrinter:=TQRPrinter(Sender);
end;

procedure TFormpreview.FormCreate(Sender: TObject);
begin
   inp:=false;
   tabsheet1.TabVisible:=false;
   tabsheet2.TabVisible:=false;
   pagecontrol1.ActivePage:=tabsheet1;
end;

procedure TFormpreview.FormActivate(Sender: TObject);
begin
   if not inp then
   begin
      inp:=true;
      quickrep1.Prepare;
      quickrep1.PreviewModal;
   end;
end;

procedure TFormpreview.Button10Click(Sender: TObject);
begin
   self.close;
end;

end.
